unit U_MyProcFunc;

interface
uses  SysUtils,  Graphics, Dialogs ;

type Point3d = record
               x:real;
               y:real;
               z:real;
               end;
type Point2d = record
               x:real;
               y:real;
               end;
type knoten_rec = record
               p1:Point3d;
               p2:Point3d;
               p3:Point3d;
               end;
var PIntersection:Point3D;
    ZinTriangle:real;


Function TColorToStr(WinColor:TColor):String;//TColor = 4-Byte-Hexadezimalzahl
Function TColorToOpenGLColor(WinColor:TColor;Nr:word):real;
Function TColorToRGB(WinColor:TColor;Nr:word):byte;
Function OpenGLColorToTColor(r,g,b:real):TColor;
Function RGBToTColor(r,g,b:cardinal):TColor;
Function IntToTColor(r,g,b:cardinal):TColor;
//----------------- Schnittpunktberechnung -------------------------------------
Function Intersection_Lines         (P1,P2,P3,P4:Point3D):boolean;//2 Linien
Function Intersection_LinesSector   (P1,P2,P3,P4:Point3d):boolean;//2 Strecken,
Function Intersection_RayLineSection(P1,P2,P3,P4:Point3D):boolean;//Strahl Strecke

Function Point_in_Triangele(P:Point3D; K:knoten_rec):boolean;
Function Triangel_visible_top(K:knoten_rec):boolean;
Function Normale_Vector(K:knoten_rec):Point3D;

//----------------- Bit setzen fragen ------------------------------------------
Function Set_BitPos(BitNumber,BitPos:cardinal):Cardinal;
Function Clear_BitPos(BitNumber,BitPos:cardinal):Cardinal;
Function Get_BitPos(BitNumber,BitPos:cardinal):Cardinal;

Function CardinalToStrBinaer(BitNumber:cardinal):string;  // Cardinal 0..4294967295 32 Bit ohne Vorz.

implementation

Function IntToTColor(r,g,b:cardinal):TColor;
var TC:Tcolor;
    a,iBit:cardinal;
begin
 TC:=0;  //schwarz
 if r>255 then r:=255;
 if g>255 then g:=255;
 if b>255 then b:=255;
 for a:=0 to 7 do  //Rot setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and r;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a); tc:=tc xor iBit;
      end;
 end;
 for a:=0 to 7 do  //Grn setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and g;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a+8); tc:=tc xor iBit;
       end;
 end;
 for a:=0 to 7 do  //Blau setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and b;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a+16); tc:=tc xor iBit;
       end;
 end;
 IntToTColor:=TC;
end;

Function OpenGLColorToTColor(r,g,b:real):TColor;
var TC:Tcolor;
    a,iBit:cardinal;
    rc,gc,bc:cardinal;
begin
 TC:=0;  //schwarz
 rc:=Round(r*255);if rc>255 then rc:=255;
 gc:=Round(g*255);if gc>255 then gc:=255;
 bc:=Round(b*255);if bc>255 then bc:=255;
 for a:=0 to 7 do  //Rot setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and rc;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a); tc:=tc xor iBit;
      end;
 end;
 for a:=0 to 7 do  //Grn setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and gc;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a+8); tc:=tc xor iBit;
       end;
 end;
 for a:=0 to 7 do  //Blau setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and bc;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a+16); tc:=tc xor iBit;
       end;
 end;
 OpenGLColorToTColor:=TC;
end;

Function TColorToOpenGLColor(WinColor:TColor;Nr:word):real;//TColor = 4-Byte-Hexadezimalzahl
var a:integer;
    iBit,iTemp:Cardinal;
begin
// RGB-Farbintensitt fr Blau, Grn und Rot
// der Wert $00FF0000 entspricht einem reinen Blau
// 1 and 1 =1    0 and 1 =0
// 1 xor 0 =1
 iTemp:=0;
 case Nr of
 1:begin  //Rot setzen
     for a:=0 to 7 do
     begin iBit:=1;
           iBit:=iBit shl(a); iBit:=iBit and WinColor;  iBit:=iBit shr(a);
           if iBit=1 then
           begin ;
            iBit:=iBit shl(a); itemp:=itemp xor iBit;
           end;
     end;
     if iTemp / 255 < 0 then TColorToOpenGLColor:=0 else
     if iTemp / 255 > 1 then TColorToOpenGLColor:=1 else
                             TColorToOpenGLColor:=iTemp / 255;
   end;
 2:begin  // Grn setzen
     for a:=0 to 7 do
     begin iBit:=1;
           iBit:=iBit shl(a+8); iBit:=iBit and WinColor;  iBit:=iBit shr(a+8);
           if iBit=1 then
           begin ;
            iBit:=iBit shl(a); itemp:=itemp xor iBit;
           end;
     end;
     if iTemp / 255 < 0 then TColorToOpenGLColor:=0 else
     if iTemp / 255 > 1 then TColorToOpenGLColor:=1 else
                             TColorToOpenGLColor:=iTemp / 255;
   end;
 3:begin  // Blau setzen
     for a:=0 to 7 do
     begin iBit:=1;
           iBit:=iBit shl(a+16); iBit:=iBit and WinColor;  iBit:=iBit shr(a+16);
           if iBit=1 then
           begin ;
            iBit:=iBit shl(a); itemp:=itemp xor iBit;
           end;
     end;
     if iTemp / 255 < 0 then TColorToOpenGLColor:=0 else
     if iTemp / 255 > 1 then TColorToOpenGLColor:=1 else
                             TColorToOpenGLColor:=iTemp / 255;
   end;
   else
    // Fehlermeldung-Ausgabe
    MessageDlg('fehlerhafter Funktions-Aufruf'+#10+
               'Function TColorToOpenGLColor(WinColor:TColor;Nr:word):real;'+#10+
               'Nr fehlerhaft(1=Rot,2=Grn,3=Blau)', mtInformation,[mbOk], 0);
    TColorToOpenGLColor:=0;
   end;
end;

Function TColorToRGB(WinColor:TColor;Nr:word):byte;//TColor = 4-Byte-Hexadezimalzahl
var a:integer;
    iBit,iTemp:Cardinal;
begin
// RGB-Farbintensitt fr Blau, Grn und Rot
// der Wert $00FF0000 entspricht einem reinen Blau
// 1 and 1 =1    0 and 1 =0
// 1 xor 0 =1
 iTemp:=0;
 case Nr of
 1:begin  //Rot setzen
     for a:=0 to 7 do
     begin iBit:=1;
           iBit:=iBit shl(a); iBit:=iBit and WinColor;  iBit:=iBit shr(a);
           if iBit=1 then
           begin ;
            iBit:=iBit shl(a); itemp:=itemp xor iBit;
           end;
     end;
     if iTemp > 255 then Result:=255 else Result:=iTemp;
   end;
 2:begin  // Grn setzen
     for a:=0 to 7 do
     begin iBit:=1;
           iBit:=iBit shl(a+8); iBit:=iBit and WinColor;  iBit:=iBit shr(a+8);
           if iBit=1 then
           begin ;
            iBit:=iBit shl(a); itemp:=itemp xor iBit;
           end;
     end;
     if iTemp > 255 then Result:=255 else Result:=iTemp;
   end;
 3:begin  // Blau setzen
     for a:=0 to 7 do
     begin iBit:=1;
           iBit:=iBit shl(a+16); iBit:=iBit and WinColor;  iBit:=iBit shr(a+16);
           if iBit=1 then
           begin ;
            iBit:=iBit shl(a); itemp:=itemp xor iBit;
           end;
     end;
     if iTemp > 255 then Result:=255 else Result:=iTemp;
   end;
   else
    // Fehlermeldung-Ausgabe
    MessageDlg('fehlerhafter Funktions-Aufruf'+#10+
               'Function TColorToRGB(WinColor:TColor;Nr:word):byte;'+#10+
               'Nr fehlerhaft(1=Rot,2=Grn,3=Blau)', mtInformation,[mbOk], 0);
    TColorToRGB:=0;
   end;
end;

Function RGBToTColor(r,g,b:cardinal):TColor;
var TC:Tcolor;
    a,iBit:cardinal;
begin
 TC:=0;  //schwarz
 if r>255 then r:=255;
 if g>255 then g:=255;
 if b>255 then b:=255;
 for a:=0 to 7 do  //Rot setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and r;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a); tc:=tc xor iBit;
      end;
 end;
 for a:=0 to 7 do  //Grn setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and g;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a+8); tc:=tc xor iBit;
       end;
 end;
 for a:=0 to 7 do  //Blau setzen
 begin iBit:=1;
       iBit:=iBit shl(a); iBit:=iBit and b;  iBit:=iBit shr(a);
       if iBit=1 then
       begin ;
         iBit:=iBit shl(a+16); tc:=tc xor iBit;
       end;
 end;
 Result:=TC;
end;


Function TColorToStr(WinColor:TColor):String;//TColor = 4-Byte-Hexadezimalzahl
var k,i,a,iB:cardinal;
    s:string;
begin
  iB:=0;a:=1;s:='';
  for i:=0 to 7 do
  begin
   if i=0 then a:=1;
   if i=1 then a:=2;
   if i>1 then a:=a*2;
   k:=1;
   k:= k shl(i);
   k:=k and WinColor;
   k:=k shr(i);
   if k=0 then iB:=iB+(a*0) else iB:=iB+(a*1);
  end;
  s:='$00'+IntToHex(iB,2);

  iB:=0;a:=1;
  for i:=8 to 15 do
  begin
   if i=8 then a:=1;
   if i=9 then a:=2;
   if i>9 then a:=a*2;
   k:=1;
   k:= k shl(i);
   k:=k and WinColor;
   k:=k shr(i);
   if k=0 then iB:=iB+(a*0) else iB:=iB+(a*1);
  end;
  s:=s+IntToHex(iB,2);

  iB:=0;a:=1;
  for i:=16 to 23 do
  begin
   if i=16 then a:=1;
   if i=17 then a:=2;
   if i>17 then a:=a*2;
   k:=1;
   k:= k shl(i);
   k:=k and WinColor;
   k:=k shr(i);
   if k=0 then iB:=iB+(a*0) else iB:=iB+(a*1);
  end;
  s:=s+IntToHex(iB,2);
  TColorToStr:=s;
end;
//------- Schnittpunktberechnung 2D, 2 Linien ----------------------------------
function Intersection_Lines(P1,P2,P3,P4:Point3D):boolean;
var deltax1,deltax2,m1,m2,n1,n2,rtemp:real;
begin
 PIntersection.x:=0;PIntersection.y:=0;PIntersection.z:=0;
 deltax1:=P2.x - P1.x;
 deltax2:=P4.x - P3.x;
 if int(deltax1*1000)=0 then
 begin
   if Int(deltax2*1000)=0 then Result:=false else
   begin
     PIntersection.x:=P2.x;
     m2:=(P4.y - P3.y) / deltax2;
     n2:=P4.y-m2*P4.x;
     PIntersection.y:=m2*PIntersection.x+n2;                    //y=mx+n
     Result:=true
   end;
 end else
 if Int(deltax2*1000)=0 then
 begin
   PIntersection.x:=P4.x;
   m1:=(P2.y - P1.y) / deltax1;
   n1:=P2.y-m1*P2.x;
   PIntersection.y:=m1*PIntersection.x+n1;                    //y=mx+n
   Result:=true;
 end else
 begin
   m1:=(P2.y - P1.y) / deltax1;
   m2:=(P4.y - P3.y) / deltax2;
   if Int(m1*1000)=Int(m2*1000) then Result:=false else
   begin
     n1:=P2.y-m1*P2.x;
     n2:=P4.y-m2*P4.x;
     rtemp:= m1-m2;
     if Int(rtemp*1000)=0 then PIntersection.x:=(n2 - n1)
                            else PIntersection.x:=(n2 - n1)/rtemp;
     PIntersection.y:=m1*PIntersection.x+n1;                    //y=mx+n
     Result:=true;
   end;
 end;
end;
//------------ Schnittpunktberechnung 2D, 2 Strecken ---------------------------
Function Intersection_LinesSector(P1,P2,P3,P4:Point3d):boolean;
var deltax, deltay,t:real;
    xs, ys,P1x,P1y,P2x,P2y,P3x,P3y,P4x,P4y:real;
begin
 if Intersection_Lines(P1,P2,P3,P4) then
 begin
   xs :=Int(PIntersection.x*1000);ys:=Int(PIntersection.y*1000);
   P1x:=Int(P1.x*1000);  P1y:=Int(P1.y*1000);
   P2x:=Int(P2.x*1000);  P2y:=Int(P2.y*1000);
   P3x:=Int(P3.x*1000);  P3y:=Int(P3.y*1000);
   P4x:=Int(P4.x*1000);  P4y:=Int(P4.y*1000);
   if (((xs>=P3x)and(xs<=P4x))or
       ((xs>=P4x)and(xs<=P3x)))and

      (((ys>=P3y)and(ys<=P4y))or
       ((ys>=P4y)and(ys<=P3y)))and

      (((xs>=P1x)and(xs<=P2x))or
       ((xs>=P2x)and(xs<=P1x)))and

      (((ys>=P1y)and(ys<=P2y))or
       ((ys>=P2y)and(ys<=P1y)))then
   begin
     deltax:=P4.x - P3.x;
     deltay:=P4.y-P3.y;
     if Int(deltax*1000)<>0 then
     begin
       t:=(PIntersection.x-P3.x) / deltax;
       PIntersection.z:=P3.z + t *(P4.z-P3.z);
     end else
     if Int(deltay*1000)<>0 then
     begin
       t:=(PIntersection.y-P3.y) / deltay;
       PIntersection.z:=P3.z + t *(P4.z-P3.z);
    end else
     begin
       if P4.z<P3.z then PIntersection.z:=P4.z
                    else PIntersection.z:=P3.z;
     end;
     result:=true;
     {f_calculate.listbox1.items.add('xs'+floattostr(PIntersection.x)+
                                  ' ys'+floattostr(PIntersection.y));}
   end else  Result:=false;
 end else  Result:=false;
end;

//----------- Schnittpunkberechnung Strahl Strecke ------------------------------
function Intersection_RayLineSection(P1,P2,P3,P4:Point3D):boolean;
var xs, ys,P3x,P3y,P4x,P4y:real;
begin
 if Intersection_Lines(P1,P2,P3,P4)then
 begin
      xs :=Int(PIntersection.x*1000);ys:=Int(PIntersection.y*1000);
      P3x:=Int(P3.x*1000);  P3y:=Int(P3.y*1000);
      P4x:=Int(P4.x*1000);  P4y:=Int(P4.y*1000);
   if(((xs>=P3x)and(xs<=P4x))or
      ((xs>=P4x)and(xs<=P3x)))and
     (((ys>=P3y)and(ys<=P4y))or
      ((ys>=P4y)and(ys<=P3y)))
   then
   begin
     if P2.x>P1.x then
     begin
       if PIntersection.x>=P1.x then result:=true else result:=false;
     end else
     begin
       if PIntersection.x<=P1.x then result:=true else result:=false;
     end;
    end else Result:=false;
 end else  Result:=false;
end;

Function Normale_Vector(K:knoten_rec):Point3D;
var VLaenge:real;
    Vu, Vv, Vn:Point3D;
begin
 Vu.x:=k.P2.x-k.P1.x;
 Vu.y:=k.P2.y-k.P1.y;
 Vu.z:=k.P2.z-k.P1.z ;
 Vv.x:=k.P3.x-k.P1.x;
 Vv.y:=k.P3.y-k.P1.y;
 Vv.z:=k.P3.z-k.P1.z;

 Vn.x:= Vu.y*Vv.z-Vu.z*Vv.y;
 Vn.y:= Vu.z*Vv.x-Vu.x*Vv.z;
 Vn.z:= Vu.x*Vv.y-Vu.y*Vv.x;
 VLaenge:=sqrt(sqr(Vn.x)+sqr(Vn.y)+sqr(Vn.z));
 if Int(VLaenge*1000)=0 then
 begin
   Vn.x:=0;
   Vn.y:=0;
   Vn.z:=1;
 end else
 begin
  Vn.x:=Vn.x / VLaenge;
  Vn.y:=Vn.y / VLaenge;
  Vn.z:=Vn.z / VLaenge;
 end;
 Result:=Vn
end;

function Point_in_Triangele(P:Point3D; K:knoten_rec):boolean;
var Pl:Point3D;
    Cut1, Cut2:boolean;
    a:integer;
    rtempU, rtempV, rtempU2, rtempV2:real;
begin
 Pl:=P; Pl.x:=P.x+10;
 Cut1:=false;
 for a:=1 to 3 do
 begin
  if a=1 then
  begin
    if Intersection_RayLineSection(P,Pl,K.P1,K.P2)then Cut1:=true;
  end else
  if a=2 then
  begin
    if Intersection_RayLineSection(P,Pl,K.P2,K.P3)then Cut1:=true;
  end else
  begin
    if Intersection_RayLineSection(P,Pl,K.P3,K.P1)then Cut1:=true;
  end;
  if Cut1 then break;
 end;

 Pl.x:=P.x-10;
 Cut2:=false;
 if Cut1 then
 for a:=1 to 3 do
 begin
  if a=1 then
  begin
    if Intersection_RayLineSection(P,Pl,K.P1,K.P2)then Cut2:=true;
  end else
  if a=2 then
  begin
    if Intersection_RayLineSection(P,Pl,K.P2,K.P3)then Cut2:=true;
  end else
  begin
    if Intersection_RayLineSection(P,Pl,K.P3,K.P1)then Cut2:=true;
  end;
  if Cut2 then break;
 end;

 if Cut1 and Cut2 then
 begin
   Result:=true;
   // Vector U in Punkt P schieben
{X}Pl.x:=P.x - (K.P2.x - K.P1.x);
   Pl.y:=P.y - (K.P2.y - K.P1.y);
   Pl.z:=0;
   // Schnittpunkt zwischen Vector U und V berechnen
   if Intersection_Lines(P,Pl,K.P1,K.P3)then
   begin
     // Vectoren U und V zum Schnittpunkt skalieren
     // Die  Z-Werte fur die Vektoren U und V skalieren
     rtempU:=sqr(K.p2.x-K.p1.x)+sqr(K.p2.y-K.p1.y);
     if Int(rtempU*1000)>0 then rtempU:=sqrt(rtempU) else rtempU:=1;
     rtempV:=sqr(K.p3.x-K.p1.x)+sqr(K.p3.y-K.p1.y);
     if Int(rtempV*1000)>0 then rtempV:=sqrt(rtempV)else rtempV:=1;
     rtempU2:=sqr(PIntersection.x-P.x)+sqr(PIntersection.y-P.y);
     if Int(rtempU2*1000)>0 then rtempU2:=sqrt(rtempU2);
     rtempV2:=sqr(PIntersection.x-K.p1.x)+sqr(PIntersection.y-K.p1.y);
     if Int(rtempV2*1000)>0 then rtempV2:=sqrt(rtempV2);

     ZinTriangle:=K.P1.z+ ((K.P2.z - K.P1.z) * (rtempu2/rtempu)) +
                          ((K.P3.z - K.P1.z) * (rtempv2/rtempv)) ;
{     f_calculate.listbox1.items.add('K.P1.z'+floattostr(K.P1.z)+
                                   ' ZinTriangle'+floattostr(ZinTriangle)+
                                   ' PIntersection.x'+floattostr(PIntersection.x)+
                                   ' PIntersection.y'+floattostr(PIntersection.y)+
                                   ' rtempu2'+floattostr(rtempu2)+
                                   ' rtempv2'+floattostr(rtempv2)
                                   ); }
 end else  ZinTriangle:=P.z;
 end else
 begin
   Result:=false;
   ZinTriangle:=P.z;
 end;
end;

function Triangel_visible_top(K:knoten_rec):boolean;
begin
 if Normale_Vector(K).z > 0.00001 then result:=true
                                  else result:=false;
end;

//------------------------------------------------------------------------------
{---  Bit von 1 bis 32 ---}
Function Set_BitPos(BitNumber,BitPos:cardinal):cardinal;
var iBit:cardinal;
begin
 iBit:=1 shl(BitPos-1); iBit:=iBit and BitNumber;  iBit:=iBit shr(BitPos-1);
 if iBit=0 then
 begin
  iBit:=1 shl(BitPos-1); Result:=BitNumber xor iBit;
 end else Result:=BitNumber;
end;

Function Clear_BitPos(BitNumber,BitPos:cardinal):cardinal;
var iBit:cardinal;
begin
 iBit:=1 shl(BitPos-1); iBit:=iBit and BitNumber;  iBit:=iBit shr(BitPos-1);
 if iBit=1 then
 begin
  iBit:=1 shl(BitPos-1); Result:=BitNumber xor iBit;
 end else Result:=BitNumber;
end;

Function Get_BitPos(BitNumber,BitPos:cardinal):Cardinal;
var iBit:cardinal;
Begin
 iBit:=1 shl(BitPos-1); iBit:=iBit and BitNumber;  iBit:=iBit shr(BitPos-1);
 Result:=iBit;
end;

Function CardinalToStrBinaer(BitNumber:cardinal):string;  // Cardinal 0..4294967295 32 Bit ohne Vorz.
var k,i:cardinal;
    sBinaer:string;
begin
  if BitNumber > 4294967295 then BitNumber:=4294967295;
  sBinaer:='';
  for i:=1 to 32 do
  begin
    k:=1;
    k:=k shl(i-1);
    k:=k and BitNumber;
    k:=k shr(i-1);
    if k=0 then sBinaer:='0'+sBinaer else sBinaer:='1'+sBinaer;
  end;
  Result:=sBinaer;
end;

end.
